# encoding: utf-8
# WARNING! Do not edit! https://waf.io/book/index.html#_obtaining_the_waf_file

import re
from waflib.Task import Task
from waflib.TaskGen import extension
from waflib import Errors
class protoc(Task):
	run_str='${PROTOC} ${PROTOC_FL:PROTOC_FLAGS} ${PROTOC_ST:INCPATHS} ${PROTOC_ST:PROTOC_INCPATHS} ${SRC[0].bldpath()}'
	color='BLUE'
	ext_out=['.h','pb.cc','.py']
	def scan(self):
		node=self.inputs[0]
		nodes=[]
		names=[]
		seen=[]
		search_nodes=[]
		if not node:
			return(nodes,names)
		if'cxx'in self.generator.features:
			search_nodes=self.generator.includes_nodes
		if'py'in self.generator.features:
			for incpath in getattr(self.generator,'protoc_includes',[]):
				search_nodes.append(self.generator.bld.path.find_node(incpath))
		def parse_node(node):
			if node in seen:
				return
			seen.append(node)
			code=node.read().splitlines()
			for line in code:
				m=re.search(r'^import\s+"(.*)";.*(//)?.*',line)
				if m:
					dep=m.groups()[0]
					for incnode in search_nodes:
						found=incnode.find_resource(dep)
						if found:
							nodes.append(found)
							parse_node(found)
						else:
							names.append(dep)
		parse_node(node)
		return(nodes,names)
@extension('.proto')
def process_protoc(self,node):
	incdirs=[]
	out_nodes=[]
	protoc_flags=[]
	self.env.PROTOC_FLAGS=self.to_list(self.env.PROTOC_FLAGS)
	if'cxx'in self.features:
		cpp_node=node.change_ext('.pb.cc')
		hpp_node=node.change_ext('.pb.h')
		self.source.append(cpp_node)
		out_nodes.append(cpp_node)
		out_nodes.append(hpp_node)
		protoc_flags.append('--cpp_out=%s'%node.parent.get_bld().bldpath())
	if'py'in self.features:
		py_node=node.change_ext('_pb2.py')
		self.source.append(py_node)
		out_nodes.append(py_node)
		protoc_flags.append('--python_out=%s'%node.parent.get_bld().bldpath())
	if not out_nodes:
		raise Errors.WafError('Feature %r not supported by protoc extra'%self.features)
	tsk=self.create_task('protoc',node,out_nodes)
	tsk.env.append_value('PROTOC_FLAGS',protoc_flags)
	for incpath in getattr(self,'protoc_includes',[]):
		incdirs.append(self.bld.path.find_node(incpath).bldpath())
	tsk.env.PROTOC_INCPATHS=incdirs
	use=getattr(self,'use','')
	if not'PROTOBUF'in use:
		self.use=self.to_list(use)+['PROTOBUF']
def configure(conf):
	conf.check_cfg(package='protobuf',uselib_store='PROTOBUF',args=['--cflags','--libs'])
	conf.find_program('protoc',var='PROTOC')
	conf.env.PROTOC_ST='-I%s'
	conf.env.PROTOC_FL='%s'
